unit UAutosize;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  StdCtrls, richedit, comctrls, forms;

type Tangle =(ta0,ta90,ta180,ta270);
   type
     TAutoSizeLabel = class(TCustomLabel)
    private
     FAngle : Tangle;
     FText  : string;
    procedure SetAngle(const Value: Tangle);
    procedure StretchText(can:Tcanvas;yer :TRect;Angle: Tangle;aText : string);
    procedure SetText(const Value: string);
    function  GetAngle(const Value :Tangle) : integer;
    protected
     procedure Paint; override;
    public
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
  published
    { Published declarations }
    property Angle : Tangle read FAngle write SetAngle default ta0;
    property Text  : string read FText write SetText ;

    property Align;
    property Font;
    property Color;
    property Transparent;
    property Visible;
    property Hint;
    property ShowHint;
    property FocusControl;
    property ParentShowHint;
    property DragCursor;
    property DragMode;
    {$IFDEF DELPHI4_LVL}
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
    property PopupMenu;
    property OnEndDock;
    property OnStartDock;
    {$ENDIF}
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    end;

procedure Register;

{$R Autosize.res}

{ TAutoSizeLabel }
implementation
     {
PROCEDURE StretchText(can:Tcanvas;yer :TRect;Angle: integer;Text : string);
Var
  TextMetric: TTextMetric;
  LogFont: TLogFont;
  A : INTEGER;
begin
//  Can.Font.Name:='Times New Roman';
  IF (Angle=0)  OR (Angle=180) THEN  Can.Font.Height:=(yer.Left-yer.Right);
  IF (Angle=90)  OR (Angle=270) THEN  Can.Font.Height:=(yer.Bottom-yer.Top);
  Can.Brush.Style:=bsClear;
  GetTextMetrics (Can.Handle,TextMetric);
  A:=Can.TextWidth(Text);
  GetObject (Can.Font.Handle,SizeOf(TLogFont),@LogFont);
  LogFont.lfEscapement:=Angle*10;
  IF (Angle=90) OR (Angle=270) THEN  LogFont.lfWidth := ROUND((YER.Bottom-yer.Top) / (A / TextMetric.tmAveCharWidth));
  IF (Angle=0)  OR (Angle=180) THEN  LogFont.lfWidth :=ROUND((YER.Right-yer.Left) /(A / TextMetric.tmAveCharWidth));
  IF (Angle=90) OR (Angle=270) THEN   LogFont.lfHeight:=YER.Right-yer.Left;
  IF (Angle=0)  OR (Angle=180) THEN   LogFont.lfHeight:=YER.Bottom-yer.Top;
  Can.Font.Handle := CreateFontIndirect(LogFont);
  IF (Angle=90)  THEN Can.TextOut(YER.Left,YER.Bottom,TEXT);
  IF (Angle=270) THEN Can.TextOut(YER.Right,YER.Top,TEXT);
  IF (Angle=0)   THEN Can.TextOut(YER.Left,YER.Top,TEXT);
  IF (Angle=180) THEN Can.TextOut(YER.Right,YER.Bottom,TEXT);

end;
   }

constructor TAutoSizeLabel.Create(AOwner: TComponent);
begin
  inherited;
  Caption:='';
  AutoSize:=false;
  Text:='Merhaba';
  Font.Name:='Arial';
  self.Width:=200;
  self.Height:=200;

end;

destructor TAutoSizeLabel.Destroy;
begin

  inherited;
end;

function TAutoSizeLabel.GetAngle(const Value: Tangle): integer;
begin
case Value of
    ta0   : Result:=0;
    ta90  : Result:=90;
    ta180 : Result:=180;
    ta270 : Result:=270;
end;
end;

procedure TAutoSizeLabel.Paint;
var
 rec:TRect;
begin
Caption:='';
  inherited ;

rec.Left:=0;
rec.Top:=0;
rec.Right:=Self.Width;
rec.Bottom:=Self.Height;
StretchText(Canvas,rec,angle,Text);

end;

procedure TAutoSizeLabel.SetAngle(const Value: Tangle);
begin
if Value<>FAngle then
  begin
  FAngle := Value;
  Invalidate;
  end;
end;

procedure TAutoSizeLabel.SetText(const Value: string);
begin
if Value<>FText then
  begin
  FText := Value;
  Invalidate;
  end;
end;

procedure TAutoSizeLabel.StretchText(can: Tcanvas; yer: TRect;
  Angle: Tangle; aText: string);
Var
  TextMetric: TTextMetric;
  LogFont: TLogFont;
  A : INTEGER;
begin
  IF (Angle=ta0)  OR (Angle=ta180) THEN  Can.Font.Height:=(yer.Left-yer.Right);
  IF (Angle=ta90)  OR (Angle=ta270) THEN  Can.Font.Height:=(yer.Bottom-yer.Top);
  Can.Brush.Style:=bsClear;
  GetTextMetrics (Can.Handle,TextMetric);
  A:=Can.TextWidth(Text);
  GetObject (Can.Font.Handle,SizeOf(TLogFont),@LogFont);
  LogFont.lfEscapement:=GetAngle(Angle) *10;
  IF (Angle=ta90) OR (Angle=ta270) THEN  LogFont.lfWidth := ROUND((YER.Bottom-yer.Top) / (A / TextMetric.tmAveCharWidth));
  IF (Angle=ta0)  OR (Angle=ta180) THEN  LogFont.lfWidth :=ROUND((YER.Right-yer.Left) /(A / TextMetric.tmAveCharWidth));
  IF (Angle=ta90) OR (Angle=ta270) THEN   LogFont.lfHeight:=YER.Right-yer.Left;
  IF (Angle=ta0)  OR (Angle=ta180) THEN   LogFont.lfHeight:=YER.Bottom-yer.Top;
  Can.Font.Handle := CreateFontIndirect(LogFont);
  IF (Angle=ta90)  THEN Can.TextOut(YER.Left,YER.Bottom,aTEXT);
  IF (Angle=ta270) THEN Can.TextOut(YER.Right,YER.Top,aTEXT);
  IF (Angle=ta0)   THEN Can.TextOut(YER.Left,YER.Top,aTEXT);
  IF (Angle=ta180) THEN Can.TextOut(YER.Right,YER.Bottom,aTEXT);

end;


procedure Register;
begin
 RegisterComponents('Nokta', [TAutoSizeLabel]);
end;


end.
